SystemOrganization addCategory: #'Iliad-More-UI'!

ILDecorator subclass: #ILMessageDecorator
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILMessageDecorator methodsFor: 'building' stamp: 'np 9/18/2009 13:37'!
contents
	^[:e |
		e build: self message.
		e build: self decoratee contents]! !

!ILMessageDecorator methodsFor: 'testing' stamp: 'np 4/24/2009 16:54'!
isGlobal
	^true! !

!ILMessageDecorator methodsFor: 'accessing' stamp: 'np 4/20/2009 16:42'!
message
	^message! !

!ILMessageDecorator methodsFor: 'accessing' stamp: 'np 9/18/2009 13:36'!
message: aBlock
	message := aBlock! !

ILApplication subclass: #ILApplicationBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILApplicationBrowser class methodsFor: 'accessing' stamp: 'np 8/18/2009 12:06'!
path
	^'browse'! !

!ILApplicationBrowser methodsFor: 'accessing' stamp: 'np 8/18/2009 12:33'!
applications
	^((ILApplication allSubclasses 
		select: [:each | each path notEmpty])
		reject: [:each | each = self class]) asSortedCollection: [:a :b |
			a name < b name]! !

!ILApplicationBrowser methodsFor: 'controllers' stamp: 'np 10/1/2009 12:42'!
index
	^self mainContents! !

!ILApplicationBrowser methodsFor: 'building' stamp: 'StevenCostiou 1/30/2010 19:00'!
mainContents
	^[:e |
		e div
			class: 'wrapper';
			build: [:div |				
				div a build: [:a |
					a href: 'http://www.iliadproject.org'.
					a img
						class: 'logo';
						src: '/images/iliad.png' alt: 'Iliad'].
				div h1: 'Application Browser'.
				div build: self pathListContents]	]! !

!ILApplicationBrowser methodsFor: 'building' stamp: 'np 10/1/2009 00:21'!
pathListContents
	^[:e || ul |
		ul := e ul.
		self applications do: [:each |
			ul li a 
				text: each name; 
				linkToApplication: each]]! !

!ILApplicationBrowser methodsFor: 'building' stamp: 'np 10/22/2009 17:02'!
updatePage: aPage
	super updatePage: aPage.
	aPage head stylesheet href: '/stylesheets/iliad.css'! !

ILWidget subclass: #ILUIWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

ILUIWidget subclass: #ILCalendar
	instanceVariableNames: 'month year actionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILCalendar methodsFor: 'accessing' stamp: 'np 4/21/2009 12:04'!
actionBlock
	^actionBlock! !

!ILCalendar methodsFor: 'accessing' stamp: 'np 4/21/2009 12:04'!
actionBlock: aBlock
	actionBlock := aBlock! !

!ILCalendar methodsFor: 'building' stamp: 'np 4/5/2010 17:34'!
calendarTableContents
	^[:e || table row date |
		table := e table.
		date := Date newDay: 1 month: self month year: self year.
		table build: self daysOfWeekRowContents.
		row := table tr.
		date dayOfWeek - 1 timesRepeat: [row td].
		date daysInMonth timesRepeat: [| selectedDate |
			selectedDate := date.
			date dayOfWeek - 1 \\ 7 = 0 ifTrue: [row := table tr].
			row td a
				action: [self selectDate: selectedDate];
				text: selectedDate dayOfMonth greaseString.
			date := date addDays: 1]]! !

!ILCalendar methodsFor: 'building' stamp: 'np 9/11/2009 10:45'!
contents
	^[:e |
		(e div class: self cssClass)
			build: self monthSelectionFormContents;
			build: self calendarTableContents]! !

!ILCalendar methodsFor: 'accessing' stamp: 'np 8/3/2009 14:05'!
cssClass
	^super cssClass, ' calendar'! !

!ILCalendar methodsFor: 'accessing' stamp: 'np 7/13/2009 00:38'!
date
	^Date newDay: 1 month: self month year: self year! !

!ILCalendar methodsFor: 'accessing' stamp: 'np 7/13/2009 00:37'!
date: aDate
	self month: aDate monthIndex.
	self year: aDate year! !

!ILCalendar methodsFor: 'accessing' stamp: 'np 4/11/2009 12:07'!
daysOfWeek
	^(1 to: 7) collect: [:i | 
		(Date nameOfDay: i) first: 3]! !

!ILCalendar methodsFor: 'building' stamp: 'np 10/1/2009 00:32'!
daysOfWeekRowContents
	^[:e || head |
		head := e thead.
		self daysOfWeek do: [:each |
			head td text: each]]! !

!ILCalendar methodsFor: 'initialization' stamp: 'np 7/13/2009 00:07'!
initialize
	super initialize.
	self date: Date today.
	actionBlock := [:val | self answer: val]! !

!ILCalendar methodsFor: 'accessing' stamp: 'np 4/11/2009 12:08'!
month
	^month! !

!ILCalendar methodsFor: 'accessing' stamp: 'np 7/13/2009 01:13'!
month: anInteger
	month := anInteger! !

!ILCalendar methodsFor: 'building' stamp: 'np 4/5/2010 19:34'!
monthSelectionFormContents
	^[:e || form select |
		form := e form class: 'month_selection'; yourself.
		select := form select.
		(1 to: 12) do: [:each || option |
			option := select option.
			option 
				text: (self months at: each);
				action: [self selectMonth: each].
			each = self month ifTrue: [option selected]].
		form input 
			maxlength: 4; 
			action: [:val | self selectYear: val];
			value: self year.
		form button text: 'select']! !

!ILCalendar methodsFor: 'accessing' stamp: 'np 7/13/2009 00:16'!
months
	^(1 to: 12) collect: [:i | 
		(Date nameOfMonth: i) first: 3]! !

!ILCalendar methodsFor: 'actions' stamp: 'np 4/21/2009 12:05'!
selectDate: aDate
	self actionBlock value: aDate! !

!ILCalendar methodsFor: 'actions' stamp: 'np 7/13/2009 00:17'!
selectMonth: anInteger.
	self month: anInteger.
	self markDirty! !

!ILCalendar methodsFor: 'actions' stamp: 'np 4/11/2009 12:33'!
selectYear: anInteger
	self year: anInteger.
	self markDirty! !

!ILCalendar methodsFor: 'accessing' stamp: 'np 7/13/2009 00:09'!
year
	^year! !

!ILCalendar methodsFor: 'accessing' stamp: 'np 7/13/2009 01:16'!
year: anInteger
	year := [anInteger asNumber] on: Error do: [:error | 1970]! !

ILUIWidget subclass: #ILDataGrid
	instanceVariableNames: 'items columnNames builders headerClass footerClass rowClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILDataGrid class methodsFor: 'defaults' stamp: 'sa 3/6/2010 14:01'!
defaultFooterClass
	^ILDataGridFooter! !

!ILDataGrid class methodsFor: 'defaults' stamp: 'sa 3/6/2010 14:01'!
defaultHeaderClass
	^ILDataGridHeader! !

!ILDataGrid class methodsFor: 'defaults' stamp: 'sa 3/6/2010 14:02'!
defaultRowClass
	^ILDataGridRow! !

!ILDataGrid methodsFor: 'building' stamp: 'sa 3/6/2010 14:13'!
body
	^[:tbody |
		self visibleItemsDo: [:item | 
			tbody build: (self rowForItem: item)]]! !

!ILDataGrid methodsFor: 'accessing' stamp: 'sa 3/6/2010 14:06'!
builders
	builders isNil ifTrue: [builders := OrderedCollection new].
	^builders! !

!ILDataGrid methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 21:45'!
column: anInteger buildContents: aBlock
	[self builders size < anInteger] whileTrue: [
		self builders addLast: [:e :item |]].
	self builders at: anInteger put: aBlock.
	self markDirty! !

!ILDataGrid methodsFor: 'accessing' stamp: 'sa 3/6/2010 14:09'!
columnNames
	^columnNames! !

!ILDataGrid methodsFor: 'accessing' stamp: 'EliGreen 10/10/2009 00:03'!
columnNames: anObject
	columnNames := anObject.
	self markDirty! !

!ILDataGrid methodsFor: 'building' stamp: 'sa 3/6/2010 14:12'!
contents
	^[:e |
		e div
			class: self cssClass;
			build: [:div |
				div table build: [:table |
					table thead build: (self headerClass new grid: self).
					table tbody build: self body.
					table tfoot build: (self footerClass new grid: self)]]]! !

!ILDataGrid methodsFor: 'accessing' stamp: 'np 10/12/2009 10:52'!
cssClass
	^super cssClass, ' datagrid'! !

!ILDataGrid methodsFor: 'building' stamp: 'sa 3/6/2010 14:05'!
footerClass
	footerClass isNil ifTrue: [
		footerClass := self class defaultFooterClass].
	^footerClass! !

!ILDataGrid methodsFor: 'building' stamp: 'sa 3/6/2010 14:04'!
headerClass
	headerClass isNil ifTrue: [
		headerClass := self class defaultHeaderClass].
	^headerClass! !

!ILDataGrid methodsFor: 'accessing' stamp: 'sa 3/6/2010 14:09'!
items
	^items! !

!ILDataGrid methodsFor: 'accessing' stamp: 'EliGreen 10/10/2009 00:17'!
items: anObject
	items := anObject.
	self markDirty! !

!ILDataGrid methodsFor: 'building' stamp: 'sa 3/6/2010 14:05'!
rowClass
	rowClass isNil ifTrue: [
		rowClass := self class defaultRowClass].
	^rowClass! !

!ILDataGrid methodsFor: 'building' stamp: 'sa 3/6/2010 14:14'!
rowForItem: anItem
	^[:tbody |
		tbody build: (self rowClass new grid: self; item: anItem)]! !

!ILDataGrid methodsFor: 'building' stamp: 'EliGreen 10/11/2009 15:56'!
visibleItemsDo: aBlock
	self items do: aBlock! !

ILDataGrid subclass: #ILPagedDataGrid
	instanceVariableNames: 'rowsPerPage currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILPagedDataGrid class methodsFor: 'defaults' stamp: 'sa 3/6/2010 14:26'!
defaultFooterClass
	^ILPagedDataGridFooter! !

!ILPagedDataGrid methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 21:46'!
currentPage
	^ (currentPage ifNil: [1]) min: self totalPages! !

!ILPagedDataGrid methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 21:46'!
currentPage: anInteger
	currentPage := anInteger.
	self markDirty! !

!ILPagedDataGrid methodsFor: 'defaults' stamp: 'StevenCostiou 1/24/2010 21:45'!
defaultRowsPerPage
	^10! !

!ILPagedDataGrid methodsFor: 'accessing' stamp: 'sa 3/6/2010 14:26'!
rowsPerPage
	^rowsPerPage ifNil: [self defaultRowsPerPage]! !

!ILPagedDataGrid methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 21:47'!
rowsPerPage: anInteger
	rowsPerPage = anInteger ifFalse: [self markDirty].
	rowsPerPage := anInteger! !

!ILPagedDataGrid methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 21:47'!
totalPages 
	^(self items size / self rowsPerPage) ceiling max: 1! !

!ILPagedDataGrid methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 21:48'!
visibleItemsDo: aBlock
	| fromIndex toIndex |

	fromIndex := ((self currentPage - 1) * self rowsPerPage) + 1.
	toIndex := (fromIndex + self rowsPerPage - 1) min: (self items size).

	fromIndex to: toIndex do: [:each |
		aBlock value: (self items at: each)].! !

ILUIWidget subclass: #ILDataGridFooter
	instanceVariableNames: 'grid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILDataGridFooter methodsFor: 'building' stamp: 'sa 3/6/2010 13:58'!
contents
	[:e |
		"nothing here"]! !

!ILDataGridFooter methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:59'!
grid
	^grid! !

!ILDataGridFooter methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:59'!
grid: anObject
	grid := anObject! !

!ILDataGridFooter methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:57'!
rootElementClass
	^ILTableRowElement! !

ILDataGridFooter subclass: #ILPagedDataGridFooter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILPagedDataGridFooter methodsFor: 'building' stamp: 'sa 3/6/2010 14:24'!
contents
	^[:tr |
		tr td
			colspan: self grid columnNames size;
			build: (ILPaginator new
				totalPages: self grid totalPages;
				currentPage: self grid currentPage;
				action: [:val | self grid currentPage: val])]! !

ILUIWidget subclass: #ILDataGridHeader
	instanceVariableNames: 'grid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILDataGridHeader methodsFor: 'building' stamp: 'sa 3/6/2010 13:43'!
contents
	^[:tr |
		self grid columnNames do: [:each |
			tr th text: each]]! !

!ILDataGridHeader methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:43'!
grid
	^grid! !

!ILDataGridHeader methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:44'!
grid: anObject
	grid := anObject! !

!ILDataGridHeader methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:22'!
rootElementClass
	^ILTableRowElement! !

ILUIWidget subclass: #ILDataGridRow
	instanceVariableNames: 'grid item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILDataGridRow methodsFor: 'building' stamp: 'sa 3/6/2010 13:51'!
contents
	^[:tr |
		self grid builders do: [:builder |
			(builder argumentCount = 3)
				ifTrue: [builder value: tr td value: item value: self]
				ifFalse: [builder value: tr td value: item]]]! !

!ILDataGridRow methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:56'!
grid
	^grid! !

!ILDataGridRow methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:56'!
grid: anObject
	grid := anObject! !

!ILDataGridRow methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:52'!
item
	^item! !

!ILDataGridRow methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:56'!
item: anObject
	item := anObject! !

!ILDataGridRow methodsFor: 'accessing' stamp: 'sa 3/6/2010 13:46'!
rootElementClass
	^ILTableRowElement! !

ILUIWidget subclass: #ILDateSelector
	instanceVariableNames: 'actionBlock selectedMonth selectedDay selectedYear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 12:03'!
actionBlock
	^actionBlock! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 12:04'!
actionBlock: aBlock
	actionBlock := aBlock! !

!ILDateSelector methodsFor: 'building' stamp: 'np 9/11/2009 11:14'!
contents
	^[:e || div form | 
		div := e div class: self cssClass.
		self selectedDateIsValid ifFalse: [
			div div 
				class: 'error';
				text: 'Invalid date'].
		form := div form.
		form
			build: self monthSelectionContents;
			build: self dayInputContents;
			build: self yearInputContents;
			space.
		form button 
			text: 'Select';
			action: [self selectDate]]! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 9/11/2009 11:19'!
cssClass
	^super cssClass, ' date_selector'! !

!ILDateSelector methodsFor: 'building' stamp: 'np 4/21/2009 14:13'!
dayInputContents
	^[:e |
		e input
			size: 2;
			value: self selectedDay;
			action: [:val | self selectDay: val]]! !

!ILDateSelector methodsFor: 'initialization' stamp: 'np 4/5/2010 17:35'!
initialize
	super initialize.
	actionBlock := [:val | self answer: val].
	selectedMonth := Date today monthName greaseString.
	selectedDay := Date today dayOfMonth.
	selectedYear := Date today year! !

!ILDateSelector methodsFor: 'building' stamp: 'np 4/21/2009 14:11'!
monthSelectionContents
	^[:e || select |
		select := e select.
		self months do: [:each || option |
			option := select option
				action: [self selectMonth: each];
				text: each]]! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:29'!
months
	^(1 to: 12) collect: [:i | 
		Date nameOfMonth: i]! !

!ILDateSelector methodsFor: 'actions' stamp: 'np 4/21/2009 14:41'!
selectDate
	self selectedDateIsValid ifFalse:[
		^self markDirty].
	self actionBlock value: self selectedDate! !

!ILDateSelector methodsFor: 'actions' stamp: 'np 4/21/2009 14:53'!
selectDay: aString
	self selectedDay: aString asInteger
	! !

!ILDateSelector methodsFor: 'actions' stamp: 'np 4/21/2009 14:53'!
selectMonth: aString
	self selectedMonth: aString
	! !

!ILDateSelector methodsFor: 'actions' stamp: 'np 4/21/2009 14:54'!
selectYear: aString
	self selectedYear: aString asInteger
	! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:37'!
selectedDate
	^Date 
		newDay: self selectedDay 
		month: self selectedMonth 
		year: self selectedYear! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/5/2010 17:35'!
selectedDate: aDate
	self selectedMonth: aDate monthName greaseString.
	self selectedDay: aDate dayOfMonth.
	self selectedYear: aDate year! !

!ILDateSelector methodsFor: 'testing' stamp: 'np 4/21/2009 14:41'!
selectedDateIsValid
	[self selectedDate] 
		on: Error
		do: [:err | ^false].
	^true! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:46'!
selectedDay
	^selectedDay! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:28'!
selectedDay: anInteger
	selectedDay := anInteger! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:46'!
selectedMonth
	^selectedMonth! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:28'!
selectedMonth: aString
	selectedMonth := aString! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:46'!
selectedYear
	^selectedYear! !

!ILDateSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:14'!
selectedYear: anInteger
	selectedYear := anInteger! !

!ILDateSelector methodsFor: 'building' stamp: 'np 4/21/2009 14:17'!
yearInputContents
	^[:e |
		e input
			size: 4;
			value: self selectedYear;
			action: [:val | self selectYear: val]]! !

ILUIWidget subclass: #ILPaginator
	instanceVariableNames: 'currentPage totalPages action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILPaginator methodsFor: 'accessing' stamp: 'EliGreen 10/11/2009 21:05'!
action
	^ action! !

!ILPaginator methodsFor: 'accessing' stamp: 'EliGreen 10/11/2009 21:05'!
action: anObject
	action := anObject! !

!ILPaginator methodsFor: 'building' stamp: 'np 4/5/2010 17:41'!
contents
	^[:e |
		self totalPages > 1 ifTrue: [
			self currentPage = 1
			ifTrue:[e text: '<<']
				ifFalse: [
					e a 
						text: '<<';
						action: [self selectPage: self currentPage- 1].
			e space].
		(1 to: self totalPages) do:[:each |
			self currentPage = each
			ifTrue: [e text: each greaseString]
			ifFalse: [
				e a
				text: each greaseString;
				action:[self selectPage: each]].
			e space].
		self currentPage = totalPages 
		ifTrue: [e text: '>>']
		ifFalse: [
			e a
			text: '>>';
			action: [self selectPage: self currentPage + 1 ]]]]

! !

!ILPaginator methodsFor: 'accessing' stamp: 'EliGreen 10/11/2009 21:04'!
currentPage
	^ currentPage! !

!ILPaginator methodsFor: 'accessing' stamp: 'EliGreen 10/11/2009 21:45'!
currentPage: anObject
	currentPage := anObject.
	self markDirty! !

!ILPaginator methodsFor: 'actions' stamp: 'StevenCostiou 1/24/2010 21:56'!
selectPage: anInteger
	self action value: anInteger! !

!ILPaginator methodsFor: 'accessing' stamp: 'sa 10/16/2009 13:24'!
totalPages
	^totalPages! !

!ILPaginator methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 21:56'!
totalPages: anInteger
	totalPages := anInteger.
	self markDirty! !

ILUIWidget subclass: #ILTimeSelector
	instanceVariableNames: 'actionBlock selectedHours selectedMinutes showSeconds selectedSeconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:30'!
actionBlock
	^actionBlock! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:30'!
actionBlock: aBlock
	actionBlock := aBlock! !

!ILTimeSelector methodsFor: 'building' stamp: 'np 9/11/2009 10:46'!
contents
	^[:e || div form |
		div := e div class: self cssClass.
		self selectedTimeIsValid ifFalse: [
			div div
				class: 'error';
				text: 'Invalid time'].
		form := div form.
		form 
			build: self hoursInputContents;
			text: ':';
			build: self minutesInputContents.
		self showSeconds ifTrue: [
			form text: ':';
			build: self secondsInputContents].
		form space.
		form button
			text: 'Select';
			action: [self selectTime]]! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 9/11/2009 11:19'!
cssClass
	^super cssClass, ' time_selector'! !

!ILTimeSelector methodsFor: 'building' stamp: 'np 4/21/2009 14:33'!
hoursInputContents
	^[:e |
		e input
			size: 2;
			value: self selectedHours;
			action: [:val | self selectHours: val]]! !

!ILTimeSelector methodsFor: 'initialization' stamp: 'np 4/21/2009 15:12'!
initialize
	super initialize.
	actionBlock := [:val | self answer: val].
	selectedHours := Time now hour24.
	selectedMinutes := Time now minute.
	selectedSeconds := Time now second! !

!ILTimeSelector methodsFor: 'building' stamp: 'np 4/21/2009 14:33'!
minutesInputContents
	^[:e |
		e input
			size: 2;
			value: self selectedMinutes;
			action: [:val | self selectMinutes: val]]! !

!ILTimeSelector methodsFor: 'building' stamp: 'np 4/21/2009 15:09'!
secondsInputContents
	^[:e |
		e input
			size: 2;
			value: self selectedSeconds;
			action: [:val | self selectSeconds: val]]! !

!ILTimeSelector methodsFor: 'actions' stamp: 'np 4/21/2009 14:54'!
selectHours: aString
	self selectedHours: aString asInteger! !

!ILTimeSelector methodsFor: 'actions' stamp: 'np 4/21/2009 14:54'!
selectMinutes: aString
	self selectedMinutes: aString asInteger! !

!ILTimeSelector methodsFor: 'actions' stamp: 'np 4/21/2009 15:09'!
selectSeconds: aString
	self selectedSeconds: aString asInteger! !

!ILTimeSelector methodsFor: 'actions' stamp: 'np 4/21/2009 14:58'!
selectTime
	self selectedTimeIsValid ifFalse:[
		^self markDirty].
	self actionBlock value: self selectedTime! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:35'!
selectedHours
	^selectedHours! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:35'!
selectedHours: anInteger
	selectedHours := anInteger! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:35'!
selectedMinutes
	^selectedMinutes! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 14:35'!
selectedMinutes: anInteger
	selectedMinutes := anInteger! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 15:09'!
selectedSeconds
	^selectedSeconds! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 15:10'!
selectedSeconds: anInteger
	selectedSeconds := anInteger! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 15:39'!
selectedTime
	^Time 
		hour: self selectedHours
		minute: self selectedMinutes
		second: self selectedSeconds! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 15:38'!
selectedTime: aTime
	self selectedHours: aTime hour24.
	self selectedMinutes: aTime minute.
	self selectedSeconds: aTime second! !

!ILTimeSelector methodsFor: 'testing' stamp: 'np 4/21/2009 15:11'!
selectedTimeIsValid
	^(0 <= self selectedHours and: [self selectedHours <= 24]) and: [
		(0 <= self selectedMinutes and: [self selectedMinutes <= 60])] and: [
			(0 <= self selectedSeconds and: [self selectedSeconds <= 60])]! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 15:08'!
showSeconds
	^showSeconds ifNil: [false]! !

!ILTimeSelector methodsFor: 'accessing' stamp: 'np 4/21/2009 15:09'!
showSeconds: aBoolean 
	showSeconds := aBoolean! !

ILUIWidget subclass: #ILTree
	instanceVariableNames: 'item expanded childrenBlock subTrees root contentsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILTree commentStamp: 'np 7/9/2009 17:05' prior: 0!
I am a graphical tree widget.

Usage example:

ILTree new
	item: Object;
	childrenBlock: [:class | class subclasses];
	contentsBlock: [:e :class | e text: class name]!

!ILTree methodsFor: 'accessing' stamp: 'np 7/5/2009 19:52'!
children
	^self childrenBlock value: self item! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/5/2009 19:52'!
childrenBlock
	^childrenBlock! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/9/2009 17:07'!
childrenBlock: aBlock
	"aBlock is used to compute the children of the given argument.
	Example: [:item | item children]"
	
	childrenBlock := aBlock! !

!ILTree methodsFor: 'actions' stamp: 'np 7/5/2009 19:52'!
collapse
	expanded := false.
	self markDirty! !

!ILTree methodsFor: 'building' stamp: 'np 9/11/2009 11:16'!
contents
	^[:e || div |
		div := e div.
		self isRoot ifTrue: [div class: self cssClass].
		div build: self contentsForItem]! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/5/2009 19:52'!
contentsBlock
	^contentsBlock! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/9/2009 17:09'!
contentsBlock: aViewBlock
	"aViewBlock takes two arguments.
	Example: [:e :item | e text: item printString]"
	
	contentsBlock := aViewBlock! !

!ILTree methodsFor: 'building' stamp: 'np 10/1/2009 00:21'!
contentsForItem
	^[:e || div |
		div := e div class: self cssClassForItem.
		self hasChildren ifTrue: [| arrow |
			arrow := div a class: 'arrow'.
			self expanded 
				ifTrue: [
					arrow img 
						src: '/images/arrow_down.png'
						alt: 'collapse'.
					arrow action: [self collapse]]
				ifFalse: [
					arrow img 
						src: '/images/arrow_right.png'
						alt: 'expand'.
					arrow action: [self expand]]].
		div space.
		self contentsBlock value: div value: self item.
		(self hasChildren and: [self expanded]) ifTrue: [| ul |
			ul := div ul.
					self subTrees do: [:each |
						ul li build: each]]]! !

!ILTree methodsFor: 'accessing' stamp: 'np 9/11/2009 11:16'!
cssClass
	^super cssClass, ' tree'! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/5/2009 19:52'!
cssClassForItem
	| str |
	str := WriteStream on: String new.
	self hasChildren ifTrue: [str nextPutAll: ' expandable'].
	self expanded ifTrue: [str nextPutAll: ' expanded'].
	^str contents! !

!ILTree methodsFor: 'actions' stamp: 'np 7/5/2009 19:52'!
expand
	expanded := true.
	self markDirty! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/5/2009 19:52'!
expanded
	^expanded ifNil: [false]! !

!ILTree methodsFor: 'testing' stamp: 'np 7/5/2009 19:52'!
hasChildren
	^self children notNil and: [self children notEmpty]! !

!ILTree methodsFor: 'testing' stamp: 'np 7/5/2009 19:52'!
isRoot
	^self root! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/5/2009 19:52'!
item
	^item! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/5/2009 19:52'!
item: anItem
	item := anItem! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/5/2009 19:52'!
root
	^root ifNil: [root := true]! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/9/2009 17:07'!
root: aBoolean
	root := aBoolean! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/5/2009 19:52'!
subTrees
	^subTrees ifNil: [
		subTrees := self children collect: [:each |
			self treeForChild: each]]! !

!ILTree methodsFor: 'accessing' stamp: 'np 7/5/2009 19:52'!
treeForChild: anObject
	^self class new
		root: false;
		childrenBlock: self childrenBlock;
		item: anObject;
		contentsBlock: self contentsBlock;
		yourself! !

!ILUIWidget methodsFor: 'accessing' stamp: 'np 8/3/2009 14:05'!
cssClass
	^'_ui'! !

ILUIWidget subclass: #ILViewTabs
	instanceVariableNames: 'views labels selectedView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILViewTabs methodsFor: 'building' stamp: 'np 10/1/2009 00:21'!
contents
	^[:e || ul div |
		div := e div class: self cssClass.
		ul := div ul.
		self views do: [:each || li |
			li := ul li.
			li a
				text: (self labelFor: each);
				linkToLocal: each.
			self selectedView = each ifTrue: [
				li class: 'selected']]]! !

!ILViewTabs methodsFor: 'accessing' stamp: 'np 9/11/2009 11:19'!
cssClass
	^super cssClass, ' tabs'! !

!ILViewTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 14:22'!
labelFor: aView
	^self labels at: (self views indexOf: aView)! !

!ILViewTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 14:21'!
labels
	^labels! !

!ILViewTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 14:21'!
labels: aCollection
	"aCollection of strings. 
	aCollection must have the same size as widgets collection"
	
	labels := aCollection! !

!ILViewTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 16:53'!
selectedView
	| route |
	route := self context route copy.
	route position: self application originalRoutePosition.
	^route next ifNil: [self views first]! !

!ILViewTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 14:21'!
views
	^views! !

!ILViewTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 14:22'!
views: aCollection
	"aCollection of strings to be displayed in the tabs.
	Each view has an associated label, set with #labels: method"
	
	views := aCollection! !

ILUIWidget subclass: #ILWidgetTabs
	instanceVariableNames: 'contentsBlock labelBlock items selectedItem hashBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILWidgetTabs methodsFor: 'building' stamp: 'np 9/7/2009 16:57'!
contents
	^[:e |
		e build: self tabsContents.
		self contentsBlock value: e value: self selectedItem]! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 16:33'!
contentsBlock
	^contentsBlock! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 16:33'!
contentsBlock: aViewBlock
	contentsBlock := aViewBlock! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/11/2009 11:19'!
cssClass
	^super cssClass, ' tabs'! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 17:01'!
hashBlock
	^hashBlock ifNil: [[:item | '']]! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 16:34'!
hashBlock: aBlock
	hashBlock := aBlock! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 16:32'!
items
	^items! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 16:32'!
items: aCollection
	items := aCollection! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 16:35'!
labelBlock
	^labelBlock! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 16:35'!
labelBlock: aBlock
	labelBlock := aBlock! !

!ILWidgetTabs methodsFor: 'actions' stamp: 'np 9/7/2009 16:37'!
selectItem: anItem
	self selectedItem: anItem.
	self markDirty! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 16:36'!
selectedItem
	^selectedItem ifNil: [self items first]! !

!ILWidgetTabs methodsFor: 'accessing' stamp: 'np 9/7/2009 16:36'!
selectedItem: anItem	
	selectedItem := anItem! !

!ILWidgetTabs methodsFor: 'building' stamp: 'np 10/1/2009 00:21'!
tabsContents
	^[:e || ul div |
		div := e div class: self cssClass.
		ul := div ul.
		self items do: [:each || li |
			li := ul li.
			li a
				text: (self labelBlock value: each);
				action: [self selectItem: each]
				hash: (self hashBlock value: each).
			self selectedItem = each ifTrue: [
				li class: 'selected']]]! !

!ILWidgetTabs methodsFor: 'updating' stamp: 'np 9/7/2009 16:45'!
updateFromHash: aString
	self items do: [:each |
		(self hashBlock value: each) = aString ifTrue: [
			self selectedItem: each. ^self]]! !

!ILWidget methodsFor: '*Iliad-More-UI' stamp: 'np 9/18/2009 13:37'!
addMessage: aBlock
	self decorateWith: ((ILMessageDecorator decoratee: self) 
		message: aBlock)! !

!ILWidget methodsFor: '*Iliad-More-UI' stamp: 'np 4/14/2009 17:44'!
lightbox: aWidget
	"show <aWidget> inside a lightbox"
	
	self lightbox: aWidget onAnswer: [:ans | ]! !

!ILWidget methodsFor: '*Iliad-More-UI' stamp: 'sa 4/17/2010 17:53'!
lightbox: aWidget onAnswer: aBlock
	"show <aWidget> inside a lightbox"
	
	self 
		show: aWidget 
		onAnswer: aBlock
		delegator: (ILLightbox new widget: aWidget; yourself)! !

ILDelegator subclass: #ILLightbox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-UI'!

!ILLightbox methodsFor: 'building' stamp: 'np 6/22/2009 15:35'!
contents
	^[:e || div |
		e build: self decoratee contents.
		e div class: 'overlay'.
		div := e div
			class: 'lightbox';
			yourself.
		div script: self lighter.
		div build: self widget]! !

!ILLightbox methodsFor: 'scripts' stamp: 'np 4/14/2009 18:37'!
lighter
	^ 'jQuery(function() {updateLightbox();jQuery(window).resize(function(){updateLightbox();})})'! !

!ILLightbox methodsFor: 'building' stamp: 'np 10/31/2009 18:14'!
scripts
	^#('/javascripts/lightbox.js')! !

!ILLightbox methodsFor: 'building' stamp: 'np 10/31/2009 18:14'!
styles
	^#('/stylesheets/lightbox.css')! !

!ILLightbox methodsFor: 'building' stamp: 'np 10/31/2009 18:34'!
updateHead: aHead.
	super updateHead: aHead.
	self decoratee updateHead: aHead! !
